     H DFTACTGRP(*NO) BNDDIR('HTTPAPI':'QC2LE')

     D EXCHRATE        PR                  ExtPgm('EXCHRATE')
     D   Country1                     3A   const
     D   Country2                     3A   const
     D   Amount                      15P 5 const
     D EXCHRATE        PI
     D   Country1                     3A   const
     D   Country2                     3A   const
     D   Amount                      15P 5 const

      /copy httpapi_h

     D Incoming        PR
     D   rate                         8F
     D   depth                       10I 0 value
     D   name                      1024A   varying const
     D   path                     24576A   varying const
     D   value                    65535A   varying const
     D   attrs                         *   dim(32767)
     D                                     const options(*varsize)

     D SOAP            s          32767A   varying
     D rc              s             10I 0
     D rate            s              8F
     D Result          s             12P 2

      /free

       if ( %parms < 3 );
          http_comp( 'Please pass parms. e.g. CALL EXCHRATE '
                   + 'PARM(USD JPY 12.00)');
          return;
       endif;

       // Note:  http_debug(*ON/*OFF) can be used to turn debugging
       //        on and off.  When debugging is turned on, diagnostic
       //        info is written to an IFS file named
       //        /tmp/httpapi_debug.txt

       http_debug(*ON);

       // Note:  http_XmlStripCRLF(*ON/*OFF) controls whether or not
       //        the XML parser removes CR and LF characters from the
       //        Xml data that's passed to your 'Incoming' procedure.

       http_XmlStripCRLF(*ON);

       SOAP =
        '<?xml version="1.0" encoding="iso-8859-1" standalone="no"?>'
       +'<SOAP:Envelope'
       +'    xmlns:SOAP="http://schemas.xmlsoap.org/soap/envelope/"'
       +'    xmlns:tns="http://www.webserviceX.NET/">'
       +'<SOAP:Body>'
       +'  <tns:ConversionRate>'
       +'      <tns:FromCurrency>'+ %trim(Country1) +'</tns:FromCurrency>'
       +'      <tns:ToCurrency>'+ %trim(Country2) + '</tns:ToCurrency>'
       +'  </tns:ConversionRate>'
       +'</SOAP:Body>'
       +'</SOAP:Envelope>';

       http_debug(*ON);

       rc = http_url_post_xml(
                  'http://www.webservicex.net/CurrencyConvertor.asmx'
                         : %addr(SOAP) + 2
                         : %len(SOAP)
                         : *NULL
                         : %paddr(Incoming)
                         : %addr(rate)
                         : HTTP_TIMEOUT
                         : HTTP_USERAGENT
                         : 'text/xml'
                         : 'http://www.webserviceX.NET/ConversionRate');

       if (rc <> 1);
          http_crash();
       else;
          Result = %dech(Amount * rate: 12: 2);
          http_comp(%trim(Country1) + ' ' + %char(%dec(Amount:12:2))
                    + ' = ' + %trim(Country2) + ' '+ %char(Result));
       endif;

       *inlr = *on;

      /end-free

     P Incoming        B
     D Incoming        PI
     D   rate                         8F
     D   depth                       10I 0 value
     D   name                      1024A   varying const
     D   path                     24576A   varying const
     D   value                    65535A   varying const
     D   attrs                         *   dim(32767)
     D                                     const options(*varsize)

     D atof            PR             8F   extproc('atof')
     D   string                        *   value options(*string)

      /free
          if (name = 'ConversionRateResult');
             rate = atof(value);
          endif;
      /end-free
     P                 E
